#include "colors.inc"
#include "shapes.inc"
#include "textures.inc"
#include "tori2.inc"

//This is a flat ring form like the rings of saturn

/*camera { //un-comment the camera and light source to view or make adjustments
  location <0 0 -2>
  direction <0 0 2>
  up        <0 1 0>
  right     <1.33 0 0>
  look_at   <0 0 2>
}*/

/*object {
  light_source {<0 10 -2> color White}
}*/

#declare Half_Torus = 
  intersection {
      quartic {
        torus07
        rotate <0 0 0>
      }
      plane {<0 1 0> 0 }
  }

object { //this is the flat ring
  intersection {
    intersection {
      Half_Torus
      rotate <0 0 180>
    }
    intersection {
      Half_Torus
    }
    translate <0 .2 0>
  }
  texture { //make it any color you like
   colour Red 1.00  colour Green 1.00  colour Blue 0.45
   ambient 0.30
   diffuse 0.30
   phong 0.25
   phong_size 0.20
 }
  rotate <-20 0 0> //to give a better view
  scale <.2 .2 .2> //optional of course
}